package 
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import com.grindheadgames.input.KeyManager;
	import flash.ui.Keyboard;
	import CustomEvents;
	import ScoreManager;
	import QTEManager;
	import ui.LolBar_DisplayManager;
	import ui.UiManager;
	
	/**
	 * ...
	 * @author Wuthrer
	 */
	public class Main extends Sprite 
	{
		/// Les trucs à afficher
		private var _ui_manager:UiManager;
		
		/// Des variables à instancier au début d'la partie
		private var _score_manager:ScoreManager;
		private var _qte_manager:QTEManager;
		
		/// Permet de gérer le state du jeu (les phases);
		/// 0 = le tout début, quand on attend que les joueurs choppent leur barbe
		/// 1 = phase de countdown, juste avant que ça commence
		/// 2 = Phase de QTE
		private var _current_phase:int = 0;
		/// Boolean permettant de définir le recovery après  le GG d'un QTE
		private var _cooldown_qte_p1:Boolean;
		private var _cooldown_qte_p2:Boolean;
		private var _cooldown_spam_p1:Boolean;
		private var _cooldown_spam_p2:Boolean;
		private var _timer_length_p4:int = 4000;
		
		/// Différents timers suivant les phases de jeu dira-t-on
		private var _timer_countdown_start:Timer = new Timer (3000, 1);
		private var _recovery_gg_qte_p1:Timer = new Timer (300, 1);
		private var _recovery_gg_qte_p2:Timer = new Timer (300, 1);
		private var _timer_p3_to_p4:Timer = new Timer (1000, 1);
		private var _timer_p3_to_p2:Timer = new Timer (1700, 1);
		private var _timer_p4:Timer;
		private var _timer_p5 = new Timer(3000, 1);
		private var _timer_to_p6 = new Timer(4500, 1);
		private var _timer_revenge = new Timer (1500, 1);
		
		public function Main():void 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// On initie tous les trucs sympas hihi
			var s = this.parent; //le stageuh;
			
			/////////////////////////////////////
			/// INSTANCES À SION
			/// Instanciation de la gestion du score
			_score_manager = new ScoreManager();
			addChild(_score_manager);
			
			/// Instanciation des éléments à afficher
			_ui_manager = new UiManager(s);
			addChild(_ui_manager);
			
			/// Instanciation du QTE
			_qte_manager = new QTEManager();
			addChild(_qte_manager);
			_qte_manager.addEventListener(CustomEvents.UPDATE_QTE, Listener_UpdateQTE, false, 0, false);
			/// Timer du recovery pour éviter de compte plusieurs fois un même QTE réussi
			_recovery_gg_qte_p1.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_recovery_gg_qte_p1, false, 0, false);
			_recovery_gg_qte_p2.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_recovery_gg_qte_p2, false, 0, false);
			_timer_p3_to_p4.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_p3_to_p4, false, 0, false);
			_timer_p3_to_p2.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_p3_to_p2, false, 0, false);
			_timer_p5.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_p5, false, 0, false);
			_timer_to_p6.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_To_P6, false, 0, false);
			_timer_revenge.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_Revenge, false, 0, false);
			
			/// Instanciation du gérage des inputs
			KeyManager.init(s);
			
			/////////////////////////////////////
			/// MOULT LISTENERS
			/// Loop du jeu
			addEventListener(Event.ENTER_FRAME, Listener_enter_frame, false, 0, false);
			/// Pour une fois que le décompte est fini au départ, pour le start
			_timer_countdown_start.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_Countdown_Start, false, 0, false);
			/// Permet de savoir lorsque le score atteint une limite qui doit déclenché un truc
			_score_manager.addEventListener(CustomEvents.SCORE_LIMIT_NEUTRAL, Listener_Score_Limit_Neutral , false, 0, false);
			_score_manager.addEventListener(CustomEvents.SCORE_LIMIT_DANGER, Listener_Score_Limit_Danger , false, 0, false);
			_score_manager.addEventListener(CustomEvents.SCORE_LIMIT_SPAM, Listener_Score_Limit_Spam , false, 0, false);
			
			
		}
		
		/// À peaufiner encore
		private function Reset_Game():void {
			_current_phase = 0;
			_timer_length_p4 = 4000;
			_score_manager.Reset_score();
			_timer_countdown_start.stop();
			_ui_manager.Reset_Game();
		}
		
		/// Le jeu tente de commencer quand les joueurs se tiennent la barbe
		private function Start_Game():void {
			_ui_manager.Start_Game();
			_timer_countdown_start.reset();
			_timer_countdown_start.start();
		}
		
		/// Fin du countdown
		private function Listener_Timer_Countdown_Start(e:TimerEvent):void {
			_timer_countdown_start.stop();
			_current_phase = 2;
			_qte_manager.Start();
			_score_manager.Start_Score();
		}
		
		/// Recovery du GG qte (pour éviter plusieurs fois le point
		private function Listener_recovery_gg_qte_p1(e:TimerEvent):void {
			_cooldown_qte_p1 = false;
		}
		
		private function Listener_recovery_gg_qte_p2(e:TimerEvent):void {
			_cooldown_qte_p2 = false;
		}
		
		/// Moteur du jeu, check les trucs à faire à chaque frame
		private function Listener_enter_frame(e:Event):void {
			
			//trace(_score_manager.CurrentScore);
			
			////////////////////////////////////////////////////////////////////////////////////////////
			////////////////////////////////////////////////////////////////////////////////////////////
			/// MOTEUR DU JEU : Gère les inputs selon la phase du jeu
			////////////////////////////////////////////////

			switch (_current_phase) {
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 0 : Les deux joueurs doivent se chopper la barbe
				case 0 :
					if (KeyManager.isKeyDown(Keyboard.W) && KeyManager.isKeyDown(Keyboard.A))
					{
						Start_Game();
						_current_phase = 1;
						return;
					}
					break;
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 1 : Ils se tiennent la barbe pendant 3 secondes, c'est le départ
				case 1:
					if (KeyManager.isKeyDown(Keyboard.W) && KeyManager.isKeyDown(Keyboard.A))
					{
						return;
					}
					else
					{
						Reset_Game();
						return;
					}
					break;
					
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 2 : Début du jeu, QTE easy qui se lance, faut détecter les inputs
				case 2 :	
					
					//////////////////////////////////////////////////////////////////
					///// On check les conditions et selon on va lancer des fonctions extérieures (marche pas dedans)
					if (KeyManager.isKeyDown(Keyboard.A) && KeyManager.isKeyDown(Keyboard.W)) {
						check_qte_p1();
						check_qte_p2();
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', false);
						_score_manager.Crit_state = 0;
					}
					/// b) Le joueur 1 tient la barbe du 2, mais le 2 ne tient pas celle du 1
					else if(KeyManager.isKeyDown(Keyboard.A) && !KeyManager.isKeyDown(Keyboard.W)) {
						check_qte_p1();
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', true);
						_score_manager.Crit_state = 1;
					}
					/// c) Le joueur 1 ne tient pas la barbe du 2, mais le 1 tient celle du 2
					else if(!KeyManager.isKeyDown(Keyboard.A) && KeyManager.isKeyDown(Keyboard.W)) {
						check_qte_p2();
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', true);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', false);
						_score_manager.Crit_state = 2;
					}
					/// d) Aucune barbe n'est tenue !
					else if(!KeyManager.isKeyDown(Keyboard.A) && !KeyManager.isKeyDown(Keyboard.W)) {
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', true);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', true);
						_score_manager.Crit_state = 3;
					}
					///////
					//////////////////////////////////////////////////////////////////
					/// Balance le current score dans l'ui manager pour qu'il affiche ce qu'il faut, notamment la lolbarre
					_ui_manager.RefreshScore(_score_manager.CurrentScore);
					break;
					
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 3 : Transition entre la phase de QTE 2 et la phase de QTE 4	
				case 3 :
					break;
				
					
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 4 : Phase de spam !	
				case 4 :
					//////////////////////////////////////////////////////////////////
					///// On check les conditions et selon on va lancer des fonctions extérieures (marche pas dedans)
					if (KeyManager.isKeyDown(Keyboard.A) && KeyManager.isKeyDown(Keyboard.W)) {
						check_spam_p1();
						check_spam_p2();
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', false);
						_score_manager.Crit_state = 0;
					}
					/// b) Le joueur 1 tient la barbe du 2, mais le 2 ne tient pas celle du 1
					else if (KeyManager.isKeyDown(Keyboard.A) && !KeyManager.isKeyDown(Keyboard.W)) {
						check_spam_p1();
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', true);
						_score_manager.Crit_state = 1;
					}
					/// c) Le joueur 1 ne tient pas la barbe du 2, mais le 2 tient celle du 1
					else if (!KeyManager.isKeyDown(Keyboard.A) && KeyManager.isKeyDown(Keyboard.W)) {
						check_spam_p2();
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', true);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', false);
						_score_manager.Crit_state = 2;
					}
					/// d) Aucune barbe n'est tenue !
					else if(!KeyManager.isKeyDown(Keyboard.A) && !KeyManager.isKeyDown(Keyboard.W)) {
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', true);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', true);
						_score_manager.Crit_state = 3;
					}
					break;
					
					
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 5 : TIME TO SLAAAAAAAAAAAAP XDDD
				case 5 :
					/// Si le joueur qui doit se faire gifler lâche la barbe, il a perdu
					switch (_score_manager.Player_spamming_avantage) 
					{
						/// JOUEUR 1 AVANTAGE, À LUI DE GIFLER
						case 1 :
							/// Le joueur 2 lâche la barbe, il perd instantanément
							if (!KeyManager.isKeyDown(Keyboard.W))
							{
								trace('JOUEUR 2 LOOSE, lâche barbe');
								_ui_manager.isGGScreenVisible(true, 1);
								_ui_manager.isSlapScreenVisible(false, 1);
								_timer_p5.stop();
								_current_phase = 3;
								_timer_to_p6.reset();
								_timer_to_p6.start();
							}
							if (KeyManager.isKeyDown(Keyboard.SPACE) && !KeyManager.isKeyDown(Keyboard.A))
							{
								_ui_manager.isGGScreenVisible(true, 1);
								_ui_manager.isSlapScreenVisible(false, 1);
								_timer_p5.stop();
								_current_phase = 3;
								_timer_to_p6.reset();
								_timer_to_p6.start();
								trace('JOUEUR 2 LOOSE, GIFLE GG');
							}
							break;
						/// JOUEUR 2 AVANTAGE, À LUI DE GIFLER
						case 2 :
							/// Le joueur 1âche la barbe, il perd instanément
							if (!KeyManager.isKeyDown(Keyboard.A))
							{
								_ui_manager.isGGScreenVisible(true, 2);
								_ui_manager.isSlapScreenVisible(false, 2);
								_timer_p5.stop();
								_current_phase = 3;
								_timer_to_p6.reset();
								_timer_to_p6.start();
								trace('JOUEUR 1 LOOSE, lâche barbe');
							}
							if (KeyManager.isKeyDown(Keyboard.SPACE) && !KeyManager.isKeyDown(Keyboard.W))
							{
								_ui_manager.isGGScreenVisible(true, 2);
								_ui_manager.isSlapScreenVisible(false, 2);
								_timer_p5.stop();
								_current_phase = 3;
								_timer_to_p6.reset();
								_timer_to_p6.start();
								trace('JOUEUR 1 LOOSE, GIFLE GG');
							}
							break;
							
					}
				break;
					
				////////////////////////////////////////////////
				////////////////////////////////////////////////
				/// PHASE 6 : APRÈS UNE VICTOIRE, POUR SAVOIR SI RESTART OU PAS
				case 6 :
					if (KeyManager.isKeyDown(Keyboard.A) || KeyManager.isKeyDown(Keyboard.W))
					{
						_ui_manager.Alerte('Restart', true);
						_timer_revenge.reset();
						_timer_revenge.start();
						/// Ici petite feinte, on vire déjà le screen de GG, pendant qu'on a le playerspamming avantage sous la main
						_ui_manager.isGGScreenVisible(false, _score_manager.Player_spamming_avantage);
						_current_phase = 3;
					}
					break;
			}
			
			////////////////////////////////////////////////////////////////////////////////////////////
			////////////////////////////////////////////////////////////////////////////////////////////
			/// MOTEUR DU JEU : Autres éléments qui doivent être checkés en enter frame
			////////////////////////////////////////////////////////////////////////////////////////////
			
			////////////////////////////////////////////////////////////////////////////////////////////
			/// Va checker l'état du score pour changer les phases ou ajuster certains éléments si nécessaires (phases par exemple)
			
			
			
		}
		
		////////////////////////////////////////////////////////////////////////////////////////////
		////////////// CHECK QTE
		////////////////////////////////////////////////////////////////////////////////////////////
		
		//////////////////////////////////////////////////////////////////
		///// Appelé par les conditions qui se trouvent dans l'enterframe en p2, on check si les QTE sont GG
		///// POUR LE JOUEUR 1
		private function check_qte_p1():void {
		/// Selon le string contenu dans la classe QTE manager, on assigne le Keycode correspondant
			var key_code_to_check_p1:int;
			switch(_qte_manager.key_to_press_p1)
			{
				case 'LEFT':
					key_code_to_check_p1 = 37;
					break;
				case 'UP' :
					key_code_to_check_p1 = 38;
					break;
				case 'RIGHT' :
					key_code_to_check_p1 = 39;
					break;
				case 'DOWN' : 
					key_code_to_check_p1 = 40;
					break;
				case 'D' :
					key_code_to_check_p1 = 68;
					break;
			}
						
			/// On check si le joueur 1 réussit un QTE
			if (KeyManager.isKeyDown(key_code_to_check_p1) && !_cooldown_qte_p1)
			{
				_cooldown_qte_p1 = true;
				_recovery_gg_qte_p1.reset();
				_recovery_gg_qte_p1.start();
				_score_manager.ScoreEvent(_current_phase, 1);
				_qte_manager.generate_new_ktp(1);
				//trace('Le joueur 1 a réussi un QTE');
			}	
		}
		/////// FIN DU CHECK QTE POUR JOUEUR 1
		//////////////////////////////////////////////////////////////////
					
		//////////////////////////////////////////////////////////////////
		///// Appelé par les conditions qui se trouvent dans l'interframe en p2, on check si les QTE sont GG
		///// POUR LE JOUEUR 2
		private function check_qte_p2():void {
			var key_code_to_check_p2:int;
			switch(_qte_manager.key_to_press_p2)
			{
				case 'LEFT':
					key_code_to_check_p2 = 37;
					break;
				case 'UP' :
					key_code_to_check_p2 = 38;
					break;
				case 'RIGHT' :
					key_code_to_check_p2 = 39;
					break;
				case 'DOWN' : 
					key_code_to_check_p2 = 40;
					break;
				case 'D' :
					key_code_to_check_p2 = 68;
					break;
			}
						
			/// On check si le joueur 2 réussit un QTE
			if (KeyManager.isKeyDown(key_code_to_check_p2) && !_cooldown_qte_p2)
			{
				_cooldown_qte_p2 = true;
				_recovery_gg_qte_p2.reset();
				_recovery_gg_qte_p2.start();
				_score_manager.ScoreEvent(_current_phase, 2);
				_qte_manager.generate_new_ktp(2);
				//trace('Le joueur 2 a réussi un QTE');
			}
		}
		/////// FIN DU CHECK QTE POUR JOUEUR 2 
		//////////////////////////////////////////////////////////////////
		
		
		////////////////////////////////////////////////////////////////////////////////////////////
		////////////// CHECK SPAMS
		////////////////////////////////////////////////////////////////////////////////////////////
		
		//////////////////////////////////////////////////////////////////
		///// Appelé par les conditions qui se trouvent dans l'enterframe en p4, on check si les SPAM sont GG
		///// POUR LE JOUEUR 1
		private function check_spam_p1():void 
		{
		/// Selon le string contenu dans la classe QTE manager, on assigne le Keycode correspondant
			var key_code_to_check_p1:int;
			switch(_qte_manager.key_to_press_p1)
			{
				case 'LEFT':
					key_code_to_check_p1 = 37;
					break;
				case 'UP' :
					key_code_to_check_p1 = 38;
					break;
				case 'RIGHT' :
					key_code_to_check_p1 = 39;
					break;
				case 'DOWN' : 
					key_code_to_check_p1 = 40;
					break;
				case 'D' :
					key_code_to_check_p1 = 68;
					break;
			}
			
			if (!KeyManager.isKeyDown(key_code_to_check_p1))
			{
				_cooldown_spam_p1 = false;
			}
						
			/// On check si le joueur 1 réussit un QTE
			if (KeyManager.isKeyDown(key_code_to_check_p1) && !_cooldown_spam_p1)
			{
				_cooldown_spam_p1 = true;
				_score_manager.ScoreEvent(_current_phase, 1);
				trace('Le joueur 1 a réussi un SPAM');
			}	
		}
		/////// FIN DU CHECK QTE POUR JOUEUR 1
		//////////////////////////////////////////////////////////////////
		
		
		//////////////////////////////////////////////////////////////////
		///// POUR LE JOUEUR 2
		private function check_spam_p2():void 
		{
		/// Selon le string contenu dans la classe QTE manager, on assigne le Keycode correspondant
			var key_code_to_check_p2:int;
			switch(_qte_manager.key_to_press_p2)
			{
				case 'LEFT':
					key_code_to_check_p2 = 37;
					break;
				case 'UP' :
					key_code_to_check_p2 = 38;
					break;
				case 'RIGHT' :
					key_code_to_check_p2 = 39;
					break;
				case 'DOWN' : 
					key_code_to_check_p2 = 40;
					break;
				case 'D' :
					key_code_to_check_p2 = 68;
					break;
			}
			
			if (!KeyManager.isKeyDown(key_code_to_check_p2))
			{
				_cooldown_spam_p2 = false;
			}
						
			/// On check si le joueur 1 réussit un QTE
			if (KeyManager.isKeyDown(key_code_to_check_p2) && !_cooldown_spam_p2)
			{
				_cooldown_spam_p2 = true;
				_score_manager.ScoreEvent(_current_phase, 2);
				trace('Le joueur 2 a réussi un SPAM');
			}	
		}
		/////// FIN DU CHECK QTE POUR JOUEUR 2
		//////////////////////////////////////////////////////////////////
		
		

		//////////////////////////////////////////////////////////////////
		///// FLORILÈGES DE LISTENER EN TOUT GENRE
		///// Lorsque le score atteint certaines limites (events lancés du score manager)
		
		/// Le curseur rentre en zone neutre
		private function Listener_Score_Limit_Neutral(e:CustomEvents):void 
		{
			trace('curseur rentre en zone neutre');
			_ui_manager.Alerte('Alerte_Zone_Spam', false);
		}
		
		/// Le curseur rentre en zone danger
		private function Listener_Score_Limit_Danger(e:CustomEvents):void 
		{
			trace('curseur rentre en zone de danger');
			_ui_manager.Alerte('Alerte_Zone_Spam', true);
		}
		
		/// Le curseur rentre en zone spam
		private function Listener_Score_Limit_Spam(e:CustomEvents):void 
		{
			trace('curseur rentre en zone spam');
			/// Permet de réajuster le curseur s'il est parti aux fraises
			if (_score_manager.CurrentScore < 0)
			{
				_ui_manager.SetCursorPosition(-285);
			}
			else if (_score_manager.CurrentScore > 0)
			{
				_ui_manager.SetCursorPosition(285);
			}
			
			_current_phase = 3;
			_score_manager.Stop_Score();
			_ui_manager.Alerte('Spam_Time', true);
			_ui_manager.isQTEVisible(false);
			_timer_p3_to_p4.reset();
			_timer_p3_to_p4.start();
			_score_manager.CurrentScore = 0;
		}
		
		/// Quand il y a un nouveau QTE qui se met en place
		private function Listener_UpdateQTE(e:CustomEvents):void {
		/// Met à jour l'affichage
			_ui_manager.RefreshQte(_qte_manager.key_to_press_p1, _qte_manager.key_to_press_p2);
		}
		
		/// Permet de mettre un mini temps et de lancer la p4. On lance tous les trucs qui se font qu'une fois
		private function Listener_Timer_p3_to_p4(e:TimerEvent):void 
		{
			_qte_manager.Start();
			_ui_manager.RefreshSpam(_qte_manager.key_to_press_p1, _qte_manager.key_to_press_p2);
			_ui_manager.isSPAMVisible(true);
			_score_manager.CurrentScore = 0;
			_current_phase = 4;
			_timer_p4 = new Timer(_timer_length_p4, 1);
			_timer_p4.addEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_p4, false, 0, false);
			_timer_p4.reset();
			_timer_p4.start();
			trace('on passe en p4');
		}
		
		
		///// Après un fail de spam, on retourne en p2
		private function Listener_Timer_p3_to_p2(e:TimerEvent):void 
		{
			switch (_score_manager.Player_spamming_avantage)
			{
				case 1:
					_score_manager.CurrentScore = 150;
					break;
				case 2:
					_score_manager.CurrentScore = -150;
					break;
			}
			
			_score_manager.CursorCurrentZone = 0;
			_score_manager.Start_Score();
			_ui_manager.isQTEVisible(true);
			_current_phase = 2;
		}
		
		/// Écoute la fin de la p4, à la fin du timer
		private function Listener_Timer_p4(e:TimerEvent):void {
			/// Ici selon le score qui a été fait, soit on retourne en zone neutre + p2, soit on c'est la p5 (finish)
			/// On check qui avait l'avantage
			_timer_p4.removeEventListener(TimerEvent.TIMER_COMPLETE, Listener_Timer_p4);
			
			switch (_score_manager.Player_spamming_avantage)
			{
				//// Si le joueur 1 avait l'avantage
				case 1:
					//// Et qu'il est parvenu à GG la phase de spam
					if (_score_manager.CurrentScore > 0) 
					{
						_ui_manager.isSlapScreenVisible(true, 1);
						_current_phase = 5;
						_score_manager.Stop_Score();
						_ui_manager.isQTEVisible(false);
						_ui_manager.isSPAMVisible(false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', false);
						_timer_p5.reset();
						_timer_p5.start();
						trace('joueur 1 gg le spam');
					}
					/// Et qu'il a perdu à la phase de spam
					else
					{
						_ui_manager.isSPAMVisible(false);
						_ui_manager.Alerte('Alerte_Fail_P4', true);
						_current_phase = 3;
						_timer_p3_to_p2.reset();
						_timer_p3_to_p2.start();
						_timer_length_p4 = _timer_length_p4 + 1000;
						trace('joueur 1 lose le spam');
					}
				break;
				
				case 2:
					if (_score_manager.CurrentScore < 0) 
					{
						_ui_manager.isSlapScreenVisible(true, 2);
						_current_phase = 5;
						_score_manager.Stop_Score();
						_ui_manager.isQTEVisible(false);
						_ui_manager.isSPAMVisible(false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player1', false);
						_ui_manager.Alerte('Alerte_GrabBeard_Player2', false);
						_timer_p5.reset();
						_timer_p5.start();
						trace('joueur 2 gg le spam');
					}
					/// Et qu'il a perdu à la phase de spam
					else
					{
						_ui_manager.isSPAMVisible(false);
						_ui_manager.Alerte('Alerte_Fail_P4', true);
						_current_phase = 3;
						_timer_p3_to_p2.reset();
						_timer_p3_to_p2.start();
						_timer_length_p4 = _timer_length_p4 + 1000;
						trace('joueur 2 lose le spam');
					}
				break;
			}
		}
		
		/// TIMER DE LA P5, s'il n'y a pas baffe ou que le joueur en fail ne lâche pas la barbe
		private function Listener_Timer_p5(e:TimerEvent):void
		{
			switch (_score_manager.Player_spamming_avantage)
			{
				case 1:
					_score_manager.CurrentScore = 150;
					break;
				case 2:
					_score_manager.CurrentScore = -150;
					break;
			}
			
			_score_manager.Start_Score();
			_score_manager.CursorCurrentZone = 0;
			_ui_manager.Alerte('Alerte_Fail_P4', true);
			_ui_manager.isSlapScreenVisible(false, _score_manager.Player_spamming_avantage);
			_ui_manager.isQTEVisible(true);
			_current_phase = 2;
		}
		
		/// TIMER AVANT DE POUVOIR RESTART LE JEU
		private function Listener_Timer_To_P6(e:TimerEvent):void
		{
			_current_phase = 6;
		}
		
		/// TIMER DE LA REVENGE, avant que le jeu ne se restarte
		private function Listener_Timer_Revenge(e:TimerEvent):void
		{
			Reset_Game();
		}
	}
	
}