package 
{
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import com.grindheadgames.input.KeyManager;
	import flash.ui.Keyboard;
	
	/**
	 * ...
	 * @author Wuthrer
	 */

	public class ScoreManager extends MovieClip
	{		
		/// Listing des différentes statistiques, genre où en est le score et la taille du cul de ta mère
		private var current_score:Number = 0;
		private var player_spamming_avantage:int;
		/// Change le calcul de l'inertie si une barbe n'est pas tenue
		/// 0 = 2 barbes tenues || 1 = joueur 1 tient la barbe, pas le 2 || 2 = joueur 1 ne tient pas la barbe, 2 oui || 3 aucun des deux ne tient
		private var _crit_state:int = 0;
		/// Permet de savoir quelle est la zone actuelle dans laquelle se trouve le curseur
		/// 0 == neutre || 1 == danger || 2 == spam
		private var cursor_current_zone:int = 0;
		
		///////////////////////////////////////
		///////////////////// Listing des différents incréments
		/// Coefficients pour l'inertie
		private static var X_INERTIE_COEF_P2:Number = 0.1;
		private static var X_INERTIE_COEF_P2_CRIT:Number = 0.5;

		/// Coefficients pour quand incrémenter lorsque GG les QTE
		private static var X_INC_QTE_GG_P1:Number = 20;
		private static var CRIT_COEFF_INC_QTE:Number = 2;
		
		/// Coefficients pour quand incrémenter lorsque GG les SPAM
		private static var X_INC_QTE_GG_P4:Number = 1;
		
		
		/// Timer pour l'inertie du curseur
		private var _TimerScoreUpdate:Timer;
		
		
		public function ScoreManager():void 
		{
			addEventListener(Event.ADDED_TO_STAGE, init, false, 0, false);
		}
		
		private function init(e:Event = null):void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			trace('Je suis le Score manager et je suis bien construit');
			
			/// Variables qui servent à l'inertie du curseur
			_TimerScoreUpdate = new Timer(50, 0);
			_TimerScoreUpdate.addEventListener(TimerEvent.TIMER, Listener_TimerScoreUpdate, false, 0, false);
			_TimerScoreUpdate.start();
		}
	
		//////////////////////////////////////////////////////////////////
		///// INERTIE CONSTANTE SUR LE CURSEUR CAR C'EST PLUS SYMPA
		public function Listener_TimerScoreUpdate(e:TimerEvent):void 
		{	
			//trace(current_score);
			/// L'inertie se calcule differemment selon la p2, si elle est en crit ou pas
			switch (_crit_state) 
			{
				case 0 :
					if (current_score == 0) 
					{
						
					}
					else if (current_score < 0) 
					{
						current_score = current_score - (X_INERTIE_COEF_P2);
					}
					else if (current_score > 0) {
						current_score = current_score + (X_INERTIE_COEF_P2);
					}
					break;
				case 1 :
					current_score = current_score + (X_INERTIE_COEF_P2_CRIT);
					break;
				case 2 :
					current_score = current_score - (X_INERTIE_COEF_P2_CRIT);
					break;
				case 3 :
					break;
			}
			
			/// Chaque fois que le score est update, check s'il change de zone
			check_if_score_reach_limit();
		}
		
		public function Stop_Score():void {
			_TimerScoreUpdate.stop();
		}
		
		public function Reset_score():void 
		{
			cursor_current_zone = 0;
			current_score = 0;
		}
		
		public function Start_Score():void 
		{
			_TimerScoreUpdate.reset();
			_TimerScoreUpdate.start();
		}
		
		
		//////////////////////////////////////////////////////////////////
		///// LORSQUE LE CURSEUR DOIT BOUGER D'UN INCREMENT PRECIS
		public function ScoreEvent(CurrentPhase:Number, WhichPlayer:int):void { 
			/// Selon dans quelle phase du jeu on est, incrémente le score pour le joueur concerné
			switch (CurrentPhase) 
			{
				///////////////////////////////////////////////////
				/// La phase 2 est la phase de QTE normal, mais elle peut être en mode crit ou pas (barbe tenue ou non)
				case 2 :
					/// Si le joueur 2 ne tient pas la barbe du joueur 1, incréments de score + forts
					if (WhichPlayer == 1)
					{
						if (_crit_state == 1) {
							current_score = current_score + (X_INC_QTE_GG_P1 * CRIT_COEFF_INC_QTE);
							//trace('Quand le joueur 1 GG + CRIT' + ' ' + current_score);
							return;
						}
						else
						{
							current_score = current_score + X_INC_QTE_GG_P1;
							//trace('Quand le joueur 1 GG' + ' ' + current_score);
							return;	
						}
						
					}
					if (WhichPlayer == 2)
					{
						/// Si le joueur 1 ne tient pas la barbe du joueur 2, incréments de score + forts
						if (_crit_state == 2) 
						{
							current_score = current_score - (X_INC_QTE_GG_P1 * CRIT_COEFF_INC_QTE);
							trace('Quand le joueur 2 GG + CRIT ' + ' ' + current_score);
							return;	
						}
						else 
						{
							current_score = current_score - X_INC_QTE_GG_P1;
							trace('Quand le joueur 2 GG' + ' ' + current_score);
							return;	
						}
						
					}
					break;
				
				///////////////////////////////////////////////////
				/// La phase 4 est la la phase de spam, un seul score
				case 4 :
					switch (WhichPlayer)
					{
						//// Ici on va simplement incrémenter positif ou négatif selon les inputs des joueurs
						case 1 :
							current_score = current_score + X_INC_QTE_GG_P4;
							break;
						case 2 :
							current_score = current_score - X_INC_QTE_GG_P4;
					}
					
			}
		}
		
		
		//////////////////////////////////////////////////////////////////
		///// PERMET DE DECLENCHER DES EVENTS ÉCOUTÉS DANS LE MAIN LORSQUE LE CURSEUR RENTRE DANS UNE ZONE
		private function check_if_score_reach_limit():void {
			//////////////////////////////////////////////////////////////////
			/// En zone neutre, donc check si va rentrer dans les zones dites de danger
			if (cursor_current_zone == 0)
			{
				if (current_score > 210 && current_score < 285) 
				{
					dispatchEvent(new CustomEvents("ScoreLimitDanger", true, true));
					cursor_current_zone = 1;
					return;
				}
				else if (current_score < -210 && current_score > -285)
				{
					dispatchEvent(new CustomEvents("ScoreLimitDanger", true, true));
					cursor_current_zone = 1;
					return;
				}
				else 
				{
					return;
				}
			}
			
			//////////////////////////////////////////////////////////////////
			/// En zone danger, donc check si va rentrer dans les zones dites de spam ou retour neutre
			else if (cursor_current_zone == 1)
			{
				//// Rentre dans les zones de spam
				if (current_score > 285) 
				{
					dispatchEvent(new CustomEvents("ScoreLimitSpam", true, true));
					cursor_current_zone = 2;
					player_spamming_avantage = 1;
					return;
				}
				else if (current_score < -285)
				{
					dispatchEvent(new CustomEvents("ScoreLimitSpam", true, true));
					cursor_current_zone = 2;
					player_spamming_avantage = 2;
					return;
				}
				//// Retourne en zone neutre
				else if (current_score < 210 && current_score >  -210)
				{
					dispatchEvent(new CustomEvents("ScoreLimitNeutral", true, true));
					cursor_current_zone = 0;
					return;
				}
				else 
				{
					return;
				}
			}
		}
		
		///////////////// GETTERS AND SETTERS
		
		public function get CurrentScore():Number {
			return current_score;
		}
		
		public function set CurrentScore(Score:Number):void
		{
			current_score = Score;
		}
		
		public function set CursorCurrentZone(Zone:int):void 
		{
			cursor_current_zone = Zone;
		}
		
		public function set Crit_state(crit_state:int):void {
			_crit_state = crit_state;
		}
		
		public function get Player_spamming_avantage():int
		{
			return player_spamming_avantage;
		}
	}
	
}