package com.grindheadgames.input
{
	import flash.display.Stage;
	import flash.events.KeyboardEvent;

	public class KeyManager
	{
		//a reference to the stage
		private static var stage:Stage,	
		//an array of pressed keys
		lib:Array = [];
		
		public function KeyManager()
		{
			
		}
		
		/**
		 * initilise the KeyManager
		 * 
		 * @param s a reference to the Stage.
		 * 
		 */		
		
		public static function init(s:Stage):void
		{
			stage = s;
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, handleKeyDown, false,0,true);
			stage.addEventListener(KeyboardEvent.KEY_UP, handleKeyUp,false,0,true);
		}
		
		/**
		 * destroy the KeyManager and free up memory for garbage collection. 
		 */		
		
		public static function destroy():void
		{
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, handleKeyDown);
			stage.removeEventListener(KeyboardEvent.KEY_UP, handleKeyUp);
		}

		/**
		 * handler for the KEY_DOWN event 
		 * @param e KeyboardEvent
		 * 
		 */		
		
		private static function handleKeyDown(e:KeyboardEvent):void
		{
			lib[e.keyCode] = true;
		}
		
		/**
		 * handler for the KEY_UP event
		 * @param e KeyboardEvent
		 * 
		 */		
		
		private static function handleKeyUp(e:KeyboardEvent):void
		{
			lib[e.keyCode] = false;
		}
		
		/**
		 * Use this method to determine if a key is down.  
		 * 
		 * @param keyCode Use the flash.ui.Keyboard class to determine if a key is down. Example: KeyManager.isKeyDown( Keyboard.Space )
		 * @return Boolean if the key is currently down, will return true, else false. 
		 * 
		 */		
		
		public static function isKeyDown( keyCode:uint ):Boolean
		{
			return lib[keyCode] as Boolean;
		}
	}
}