package ui {
	
	import flash.display.MovieClip;
	import flash.display.Stage;
	import flash.events.Event;
	import flash.text.TextField;
	import ui.LolBar_DisplayManager;
	
	/**
	 * ...
	 * @author Wuthrer
	 */
	public class UiManager extends MovieClip 
	{
		public var _stage:Stage;
		
		/// Instanciation des enfants de l'affichage
		private static var _lolBar:LolBar_DisplayManager;
		private static var _QTE:QTE_DisplayManager;
		private var _Screen_GG_p2:SCREEN_GG_p2;
		private var _Screen_GG_p1:SCREEN_GG_p1;
		
		/// Les éléments qui sont dans le ui, direc'
		private var _tf_StartTitle;
		private var _tf_StartCountDown;
		private var _alert_GrabOpponentBeard_p1;
		private var _alert_GrabOpponentBeard_p2;
		private var _alert_spam;
		private var _alert_fail_p4;
		private var _slap_screen;
		private var _revenge_screen;
		
		public function UiManager(s:Stage):void {
			_stage = s;
			addEventListener(Event.ADDED_TO_STAGE, init, false, 0, false);
		}
		
		private function init(e:Event=null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			
			/// Instanciation des différents éléments de l'UI
			_lolBar = new LolBar_DisplayManager();
			_QTE = new QTE_DisplayManager();
			_Screen_GG_p2 = new SCREEN_GG_p2();
			_Screen_GG_p1 = new SCREEN_GG_p1();
			
			/// Ajout à la liste d'affichage
			addChildAt(_lolBar, 0);
			addChild(_QTE);
			
			/// On récup les éléments qui sont déjà dans le container
			for (var i:int = 0 ; i < numChildren ; i++) {
				if (getChildAt(i).name == 'TF_StartTitle') 
				{
					_tf_StartTitle = getChildAt(i);
				}
				else if (getChildAt(i).name == 'TF_StartCountDown')
				{
					_tf_StartCountDown = getChildAt(i);
				}
				else if (getChildAt(i).name == 'Alert_GrabOpponentBeard_p1')
				{
					_alert_GrabOpponentBeard_p1 = getChildAt(i);
					_alert_GrabOpponentBeard_p1.visible = false;
				}
				else if (getChildAt(i).name == 'Alert_GrabOpponentBeard_p2')
				{
					_alert_GrabOpponentBeard_p2 = getChildAt(i);
					_alert_GrabOpponentBeard_p2.visible = false;
				}
				else if (getChildAt(i).name == 'Alerte_Spam')
				{
					_alert_spam = getChildAt(i);
				}
				else if (getChildAt(i).name == 'Alerte_FailSpam')
				{
					_alert_fail_p4 = getChildAt(i);
				}
				else if (getChildAt(i).name == 'SLAP_SCREEN')
				{
					_slap_screen = getChildAt(i);
				}
				else if (getChildAt(i).name == 'SCREEN_REVENGE')
				{
					_revenge_screen = getChildAt(i);
				}
			}
			
		}
		
		public function Reset_Game():void {
			_tf_StartTitle.visible = true;
			_alert_GrabOpponentBeard_p1.visible = false;
			_alert_GrabOpponentBeard_p2.visible = false;
			_tf_StartCountDown.gotoAndStop(0);
			Alerte('Restart', false);
			RefreshScore(0);
			_lolBar.Anim_Cursor(1);
			isQTEVisible(true);
			_QTE.set_tf(1, 'Player 1');
			_QTE.set_tf(2, 'Player 2');
		}
		
		public function Start_Game():void {
			_tf_StartTitle.visible = false;
			_tf_StartCountDown.play();
		}
		
		/// Appelé depuis la loop du main, met à jour le score
		public function RefreshScore(CurrentScore:Number):void {
			_lolBar.Adjust_cursor(CurrentScore);
		}
		
		public function SetCursorPosition(Position:Number):void
		{
			_lolBar.Set_cursor_position(Position);
		}
		
		/// Permet de mettre à jour le champ de texte du QTE
		public function RefreshQte(Ktp_p1:String, Ktp_p2:String):void {
			_QTE.set_tf(1, Ktp_p1);
			_QTE.set_tf(2, Ktp_p2);
		}
		
		public function RefreshSpam(Ktp_p1:String, Ktp_p2:String):void 
		{
			_QTE.set_spam(1, Ktp_p1);
			_QTE.set_spam(2, Ktp_p2);
		}
		
		public function isSPAMVisible(YesOrNo:Boolean):void
		{
			if (YesOrNo)
			{
				_QTE.is_SPAM_VisibleOrNo(true);
			}
			else 
			{
				_QTE.is_SPAM_VisibleOrNo(false);
			}
		}
		
		public function isQTEVisible(YesOrNo:Boolean):void
		{
			if (YesOrNo)
			{
				_QTE.is_QTE_VisibleOrNo(true);
			}
			else 
			{
				_QTE.is_QTE_VisibleOrNo(false);
			}
		}
		
		
		/// Permet de gérer le SlapScreen final !
		public function isSlapScreenVisible(YesOrNo:Boolean, WhichPlayer:int):void 
		{
			switch (WhichPlayer) 
			{
				case 1:
					_slap_screen.gotoAndPlay('PLAYER_1');
					break;
				case 2:
					_slap_screen.gotoAndPlay('PLAYER_2');
					break;
			}
				
			if (YesOrNo)
			{
				_slap_screen.visible = true;
				
			}
			else 
			{
				_slap_screen.visible = false;
			}
		}
		
		/// Pour gérer l'écran de fin
		public function isGGScreenVisible(YesOrNo:Boolean, WhichPlayerWon:int):void
		{
			switch (YesOrNo) 
			{
				case true :
					if (WhichPlayerWon == 1)
					{
						addChild(_Screen_GG_p1);
						_Screen_GG_p1.x = 400;
						_Screen_GG_p1.y = 300;
						_Screen_GG_p1.play();
						return;
					}
					else if (WhichPlayerWon == 2)
					{
						addChild(_Screen_GG_p2);
						_Screen_GG_p2.x = 400;
						_Screen_GG_p2.y = 300;
						_Screen_GG_p2.play();
						return;
					}
				break;
				
				case false :
					if (WhichPlayerWon == 1)
					{
						_Screen_GG_p1.gotoAndStop(1);
						removeChild(_Screen_GG_p1);
						return;
					}
					else if (WhichPlayerWon == 2)
					{
						_Screen_GG_p2.gotoAndStop(1);
						removeChild(_Screen_GG_p2);
						return;
					}
					else 
					{
					trace('impossible de virer lecran de GG');
					}
				break;
			}
		}

		
		/// Permet de faire pop les alertes, selon leur nom hihi
		public function Alerte(AlerteName:String, State:Boolean):void {
			
			/// Le State définit si ça pop (true) ou si ça dépop (false)
			if (State) /// Ici le state est true, donc on fait pop
			{
				switch (AlerteName) 
				{
					case 'Alerte_GrabBeard_Player1' :
						_alert_GrabOpponentBeard_p1.visible = true;
						setChildIndex(_alert_GrabOpponentBeard_p1, numChildren-1);
						break;
					case 'Alerte_GrabBeard_Player2' :
						_alert_GrabOpponentBeard_p2.visible = true;
						setChildIndex(_alert_GrabOpponentBeard_p2, numChildren-1);
						break;
					case 'Alerte_Zone_Spam' :
						_lolBar.Anim_Cursor(2);
						break;
					case 'Spam_Time' :
						_alert_spam.gotoAndPlay(2);
						break;
					case 'Alerte_Fail_P4' :
						_alert_fail_p4.visible = true;
						_alert_fail_p4.play();
						break;	
					case 'Restart' :
						_lolBar.visible = false;
						_revenge_screen.visible = true;
						break;
						
				}
			}
			else /// Au contraire s'il est false, on fait dépop
			{
				switch (AlerteName)
				{
					case 'Alerte_GrabBeard_Player1' :
						_alert_GrabOpponentBeard_p1.visible = false;
						break;
					case 'Alerte_GrabBeard_Player2' :
						_alert_GrabOpponentBeard_p2.visible = false;
						break;
					case 'Alerte_Zone_Spam' :
						_lolBar.Anim_Cursor(1);
						break;
					case 'Alerte_Fail_P4' :
						_alert_fail_p4.visible = false;
						_alert_fail_p4.gotoAndStop(1);
						break;
					case 'Restart' :
						_lolBar.visible = true;
						_revenge_screen.visible = false;
				}
			}
			
		}
	}
	
}